/*
 *
 * For the FUTABA 7 segment VFD on the Artisan Media centre case
 *
 * This is a very simple dummy module. All it does is to add the
 * futaba VID and PID into the in kernel HID quirks list.
 *
 * After this the display can be reset and the HID subsystem then
 * will not crash it by asking for reports. At that point we can use
 * a user land driver for the display :)
 *
 *
 */

//---------------------INCLUDES------------------------------------------------
#include <linux/init.h>
#include <linux/types.h>
#include <linux/module.h>
#include <linux/hid.h>

//---------------------DEFINES-------------------------------------------------
#define VENDOR_ID 0x0547
#define PRODUCT_ID 0x7000

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Steve Williams");

//--------------------Function declarations------------------------------------
static int futaba_quirks_init(void);
static void futaba_quirks_exit(void);

static int (*p_usbhid_modify_dquirk)(uint16_t vendor,uint16_t product,uint32_t quirk) = 
//
// Here is the botch. You need to find the address of *your* kernel symbol 
// usbhid_modify_dquirk() (usually in Symbols.map in /boot)

(void *)0xc05b6746;

static int futaba_quirks_init(void)
{
	int n;


	if( (n = p_usbhid_modify_dquirk(VENDOR_ID,PRODUCT_ID,HID_QUIRK_NOGET)) )
	{
		printk(KERN_ALERT "usbhid_modify_dquirk() FAILED with %d\n",n);
	}
	else
	{
		printk(KERN_ALERT "Futaba Quirks work around in place\n");
	}	

	return n;
}

static void futaba_quirks_exit(void)
{
	printk(KERN_ALERT "Futaba quirks fixer exit\n");

}

module_init(futaba_quirks_init);
module_exit(futaba_quirks_exit);
